--
-- Scipt fr Schneeketten
--
-- @author  Grisu118
-- @date  05/11/11
--
K700Ketten = {}

function K700Ketten.prerequisitesPresent(specializations)
    return true;
end;

function K700Ketten:load(xmlFile)

	self.setAdditionalketten = SpecializationUtil.callSpecializationsFunction("setAdditionalketten");

	self.Ketten = {};
	self.Ketten[1] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Ketten#index1"));
	self.Ketten[2] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Ketten#index2"));
	self.Ketten[3] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Ketten#index3"));
	self.Ketten[4] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Ketten#index4"));
	self.Ketten.node = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.Ketten#indexDuel"));
	
	self.KetteMode = 0;	
	self.Kette1Active = false;
	self.Kette2Active = false;
	self.Kette3Active = false;
	self.Kette4Active = false;
	
end;
      
function K700Ketten:delete()
end;

function K700Ketten:readStream(streamId, connection)
	self:setAdditionalketten(streamReadInt8(streamId), true);
end;

function K700Ketten:writeStream(streamId, connection)
	streamWriteInt8(streamId, self.duels);	
end;

function K700Ketten:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function K700Ketten:keyEvent(unicode, sym, modifier, isDown)
end;

function K700Ketten:update(dt)

	if not self:getIsActive() then


		if self.playerInRange then
		g_currentMission:addHelpButtonText(g_i18n:getText("Ketten"), InputBinding.IMPLEMENT_EXTRA3);
		if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA3) then
			if self.KetteMode > 2 then
				self.KetteMode = 0;
			end;
			self:setAdditionalketten(math.abs(self.KetteMode + 1));
		end;
		end;
	end;


end;

function K700Ketten:updateTick(dt)	
	if g_currentMission.player ~= nil then
		local nearestDistance = 4.0;
		local x1,y1,z1 = getWorldTranslation(self.Ketten.node);
		local x2,y2,z2 = getWorldTranslation(g_currentMission.player.rootNode);
		local distance = Utils.vector3Length(x1-x2,y1-y2,z1-z2);
		if distance < nearestDistance then
			self.playerInRange = true; 
		else
			self.playerInRange = false; 
		end;
	end;
end;

function K700Ketten:onLeave()
end;

function K700Ketten:draw()


end;

function K700Ketten:setAdditionalketten(duels, noEventSend)
	AdditionalkettenEvent.sendEvent(self, duels, noEventSend);

	self.KetteMode = duels;

	if self.KetteMode == 0  then
	self.Kette1Active = false;
	self.Kette2Active = false;
	self.Kette3Active = false;
	self.Kette4Active = false;
	
	self.wheels[1].lateralStiffness =1
	self.wheels[2].lateralStiffness =1
	self.wheels[3].lateralStiffness =1
	self.wheels[4].lateralStiffness =1
	
	self.wheels[1].longitudalStiffness =1
	self.wheels[2].longitudalStiffness =1
	self.wheels[3].longitudalStiffness =1
	self.wheels[4].longitudalStiffness =1
		
	end;
	if self.KetteMode == 1 then
	self.Kette1Active = true;
	self.Kette2Active = true;
	self.Kette3Active = false;
	self.Kette4Active = false;
	
	self.wheels[1].lateralStiffness =1
	self.wheels[2].lateralStiffness =1
	self.wheels[3].lateralStiffness =12
	self.wheels[4].lateralStiffness =12
	
	self.wheels[1].longitudalStiffness =1
	self.wheels[2].longitudalStiffness =1
	self.wheels[3].longitudalStiffness =12
	self.wheels[4].longitudalStiffness =12
	end;
	if self.KetteMode == 2 then
	self.Kette1Active = true;
	self.Kette2Active = true;
	self.Kette3Active = true;
	self.Kette4Active = true;
		
	self.wheels[1].lateralStiffness =12
	self.wheels[2].lateralStiffness =12
	self.wheels[3].lateralStiffness =12
	self.wheels[4].lateralStiffness =12
	
	self.wheels[1].longitudalStiffness =12
	self.wheels[2].longitudalStiffness =12
	self.wheels[3].longitudalStiffness =12
	self.wheels[4].longitudalStiffness =12
	end;
	if self.KetteMode == 3  then
	self.Kette1Active = false;
	self.Kette2Active = false;
	self.Kette3Active = false;
	self.Kette4Active = false;
		
	self.wheels[1].lateralStiffness =1
	self.wheels[2].lateralStiffness =1
	self.wheels[3].lateralStiffness =1
	self.wheels[4].lateralStiffness =1
	
	self.wheels[1].longitudalStiffness =1
	self.wheels[2].longitudalStiffness =1
	self.wheels[3].longitudalStiffness =1
	self.wheels[4].longitudalStiffness =1
	end;	
	
	
	setVisibility(self.Ketten[1], self.Kette1Active);
	setVisibility(self.Ketten[2], self.Kette2Active);
	setVisibility(self.Ketten[3], self.Kette3Active);
	setVisibility(self.Ketten[4], self.Kette4Active);




end;

AdditionalkettenEvent = {};
AdditionalkettenEvent_mt = Class(AdditionalkettenEvent, Event);

InitEventClass(AdditionalkettenEvent, "AdditionalkettenEvent");

function AdditionalkettenEvent:emptyNew()
    local self = Event:new(AdditionalkettenEvent_mt);
    self.className="AdditionalkettenEvent";
    return self;
end;

function AdditionalkettenEvent:new(vehicle, duels)
    local self = AdditionalkettenEvent:emptyNew()
    self.vehicle = vehicle;
	self.duels = duels;
    return self;
end;

function AdditionalkettenEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.duels = streamReadInt8(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function AdditionalkettenEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));	
	streamWriteInt8(streamId, self.duels);	
end;

function AdditionalkettenEvent:run(connection)
	self.vehicle:setAdditionalketten(self.duels, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(AdditionalkettenEvent:new(self.vehicle, self.duels), nil, connection, self.object);
	end;
end;

function AdditionalkettenEvent.sendEvent(vehicle, duels, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(AdditionalkettenEvent:new(vehicle, duels), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(AdditionalkettenEvent:new(vehicle, duels));
		end;
	end;
end;